Attribute VB_Name = "Module1"
Public stream1 As Long          'the stream we open
Public channel1 As Long         'the channel we play the stream in
Public dsp1 As Long

Public lp_reson As Single
Public lp_cutoff As Single

'Set this to false to disable effects
'Note, these effects cannot be used in Visual Basic,
'unless you put the fmod_dsp_lowpass.dll in your windows/system dir
'When you compile the program before starting it, there is no problem
Public Const USE_EFFECTS = True

'LowPass
Public Declare Function dsp_lowpass_create Lib "fmod_dsp_lowpass.dll" (ByVal stream As Long, ByVal Priority As Long, ByVal nr As Long) As Long
Public Declare Function dsp_LowPassClose Lib "fmod_dsp_lowpass.dll" (ByVal nr As Long) As Long
Public Declare Function dsp_SetLowPassParams Lib "fmod_dsp_lowpass.dll" (ByVal cutoff As Single, ByVal reson As Single, ByVal nr As Long) As Long
'Some Explanation about the lowpass functions
'dsp_lowpass_create creates a lowpass dsp by calling FSOUND_DSP_Create
'this can't be done in VB for some reason (it crashes), so you have to use this function instead
'the parameter nr is the number. you can have 0 or 1
'so you can have two streams with different effect parameters

Public UseSpectrum As Boolean
Public UseBPMDetect As Boolean

Public Function FormatTime(ByVal sec As Long, Optional ByVal FullWords As Boolean = False) As String
Dim s As Long
Dim m As Long
Dim h As Long

s = sec
m = 0
h = 0
If s >= 60 Then
    m = Int(s / 60)
    s = s - m * 60
End If
If m >= 60 Then
    h = Int(m / 60)
    m = m - h * 60
End If

If Not FullWords Then
    If h > 0 Then
        FormatTime = Format$(h, "00") & ":"
    End If
    FormatTime = FormatTime & Format$(m, "00") & ":" & Format$(s, "00")
Else
    If h > 0 Then
        FormatTime = h & " Hours, "
    End If
    If m > 0 Then
        FormatTime = FormatTime & m & " Minutes, "
    End If
    FormatTime = FormatTime & s & " Seconds"
End If
End Function

Public Function vis_GetSpectrumCount(ByVal a As Long, Optional ByVal Width = 32)
Dim d As Long
If Width = 32 Then
    If a = 0 Then d = 1
    If a = 1 Then d = 1
    If a = 2 Then d = 1
    If a = 3 Then d = 1
    If a = 4 Then d = 1
    If a = 5 Then d = 2
    If a = 6 Then d = 2
    If a = 7 Then d = 2
    If a = 8 Then d = 2
    If a = 9 Then d = 3
    If a = 10 Then d = 3
    If a = 11 Then d = 4
    If a = 12 Then d = 4
    If a = 13 Then d = 5
    If a = 14 Then d = 5
    If a = 15 Then d = 6
    If a = 16 Then d = 6
    If a = 17 Then d = 8
    If a = 18 Then d = 8
    If a = 19 Then d = 9
    If a = 20 Then d = 10
    If a = 21 Then d = 11
    If a = 22 Then d = 12
    If a = 23 Then d = 14
    If a = 24 Then d = 15
    If a = 25 Then d = 17
    If a = 26 Then d = 18
    If a = 27 Then d = 20
    If a = 28 Then d = 21
    If a = 29 Then d = 24
    If a = 30 Then d = 25
    If a = 31 Then d = 27
ElseIf Width = 16 Then
    If a = 0 Then d = 2
    If a = 1 Then d = 2
    If a = 2 Then d = 3
    If a = 3 Then d = 4
    If a = 4 Then d = 5
    If a = 5 Then d = 7
    If a = 6 Then d = 9
    If a = 7 Then d = 11
    If a = 8 Then d = 14
    If a = 9 Then d = 17
    If a = 10 Then d = 21
    If a = 11 Then d = 30 '26
    If a = 12 Then d = 35 '32
    If a = 13 Then d = 40 '38
    If a = 14 Then d = 50 '45
    If a = 15 Then d = 60 '52
End If
    vis_GetSpectrumCount = d
End Function

Public Sub vis_SimplifySpectrum(ByRef src() As Single, ByRef dst() As Single)
Dim up As Long, a As Long, b As Long, d As Long, c As Long, cnt As Double, wdth As Long
Static max16(15) As Double
Static max32(31) As Double

Dim tmpDbl As Double
up = UBound(dst)
If up >= 31 Then
    wdth = 32
ElseIf up >= 15 Then
    wdth = 16
Else
    Exit Sub
End If

For a = 0 To UBound(dst)
    d = vis_GetSpectrumCount(a, wdth)

    cnt = 0
    For c = 1 To d
        If UBound(src) >= b Then
            cnt = cnt + src(b)
        End If
        b = b + 1
    Next
    
    If cnt > 0 Then
        If cnt > 0 Then tmpDbl = Sqr(cnt)
        If wdth = 16 Then
            If tmpDbl > max16(a) Then max16(a) = tmpDbl
            If max16(a) > 0 Then
                tmpDbl = tmpDbl / max16(a)
            Else
                tmpDbl = 0
            End If
        ElseIf wdth = 32 Then
            If tmpDbl > max32(a) Then max32(a) = tmpDbl
            If max32(a) > 0 Then
                tmpDbl = tmpDbl / max32(a)
            Else
                tmpDbl = 0
            End If
        End If
    Else
        tmpDbl = 0
    End If
    dst(a) = tmpDbl
Next

End Sub

